﻿Imports System.ComponentModel
Imports System.Reflection
Imports System.IO


Public Class SlideShowMain
#Region "変数"
    Private prop_FileList As List(Of String)
    Private prop_Interval As Integer = 3
    Private prop_CurItem As Integer

    Const MAX_INTERVAL As Integer = 60 ' 最大Interval秒
    Const FRAMEFOLDERNAME As String = "FrameImages"

    Private m_poiMouse As Point
    Private m_bToolSMoveMode As Boolean = False
#End Region

#Region "システム関数"
    ''' <summary>
    ''' 初期化処理
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub SlideShowMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        If DesignMode Then
            Return
        End If
        Me.ParentForm.WindowState = FormWindowState.Maximized
        Me.SizAble = False
        Me.MovAble = False

        Try
            Dim strTemp As String()
            Dim i As Integer = 0

            For Each strItem As String In ComboTimer.Items
                strTemp = Split(strItem)
                If Interval = Convert.ToInt32(strTemp(0)) Then
                    ComboTimer.ComboBox.SelectedIndex = i
                    Exit For
                End If
                i = i + 1
            Next
        Catch ex As Exception

        End Try

        ' フレーム表示
        Try
            Dim foldername As String
            Dim filename As String
            Dim i As Integer
            Dim tsi As ToolStripMenuItem
            ' モジュールのフォルダ取得
            Dim modules() As System.Reflection.Module = Assembly.GetExecutingAssembly.GetModules()
            foldername = Path.GetDirectoryName(modules(0).FullyQualifiedName)
            foldername += "\"
            foldername += FRAMEFOLDERNAME

            Dim sFiles As String()
            sFiles = Directory.GetFiles(foldername, "*.png")

            For Each sFile As String In sFiles
                Try
                    tsi = New ToolStripMenuItem
                    tsi.Name = Path.GetFileName(sFile)
                    tsi.Text = Path.GetFileNameWithoutExtension(sFile)
                    tsi.CheckState = CheckState.Unchecked
                    MenuFrame.DropDownItems.Add(tsi)
                Catch ex As Exception

                End Try
            Next

            i = 0
            If My.Settings.FrameName IsNot Nothing Then
                If My.Settings.FrameName.Length > 0 Then
                    ' 保存された設定情報があれば反映
                    filename = foldername + "\" + My.Settings.FrameName
                    PictureBox1.Image = Image.FromFile(filename)

                    i = MenuFrame.DropDownItems.IndexOfKey(My.Settings.FrameName)
                End If
            End If
            If i > 0 Then
                tsi = MenuFrame.DropDownItems.Item(i)
                tsi.CheckState = CheckState.Checked
                tsi.Select()
            Else
                tsi = MenuFrame.DropDownItems.Item(0)
                tsi.CheckState = CheckState.Checked
                tsi.Select()
            End If
        Catch ex As Exception

        End Try

        ActiveControl = PictureBox1
    End Sub

    ''' <summary>
    ''' フォーカス周りの調整
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub ComboTimer_Leave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboTimer.Leave
        ToolStrip1.Enabled = False
        Me.Focus()
        ActiveControl = PictureBox1
        ToolStrip1.Enabled = True
    End Sub

    ''' <summary>
    ''' 各種キー操作
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub SlideShowMain_PreviewKeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PreviewKeyDownEventArgs) Handles MyBase.PreviewKeyDown
        Select Case e.KeyCode
            Case Keys.Escape
                Me.ParentForm.Close()

            Case Keys.Space
                Play()

            Case Keys.Enter
                If e.Alt Then
                    MaximizeChange()
                Else
                    ToolStrip1.Visible = Not ToolStrip1.Visible
                End If

            Case Keys.Up
                If ComboTimer.SelectedIndex > 0 Then
                    ComboTimer.SelectedIndex = ComboTimer.SelectedIndex - 1
                    ToolStrip1.Enabled = False
                    Me.Focus()
                    ActiveControl = PictureBox1
                    ToolStrip1.Enabled = True
                End If

            Case Keys.Down
                If ComboTimer.SelectedIndex < ComboTimer.Items.Count - 1 Then
                    ComboTimer.SelectedIndex = ComboTimer.SelectedIndex + 1
                    ToolStrip1.Enabled = False
                    Me.Focus()
                    ActiveControl = PictureBox1
                    ToolStrip1.Enabled = True
                End If

            Case Keys.Right
                ShowNextImage()
            Case Keys.Left
                ShowPrevImage()
        End Select
    End Sub

    ''' <summary>
    ''' マウス押下処理
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub SlideShowMain_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDown
        If m_bToolSMoveMode Then
            Return
        End If

        Me.Focus()
        If e.Button = Windows.Forms.MouseButtons.Left Then

        ElseIf e.Button = Windows.Forms.MouseButtons.Right Then
            ToolStrip1.Visible = Not ToolStrip1.Visible
        End If
    End Sub

    ''' <summary>
    ''' ダブルクリック処理
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub SlideShowMain_MouseDoubleClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDoubleClick
        If e.Button = Windows.Forms.MouseButtons.Left Then
            MaximizeChange()
        End If
    End Sub

    ''' <summary>
    ''' サイズ変更時の処理
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub SlideShowMain_Resize(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        If ToolStrip1 IsNot Nothing Then
            Dim newpt As Point = ToolStrip1.Location
            If newpt.X + ToolStrip1.Width > Me.Width Then
                newpt = New Point(Me.Width - ToolStrip1.Width, newpt.Y)
            End If
            If newpt.Y + ToolStrip1.Height > Me.Height Then
                newpt = New Point(newpt.X, Me.Height - ToolStrip1.Height)
            End If
            If newpt.X < 0 Then
                newpt = New Point(0, newpt.Y)
            End If
            If newpt.Y < 0 Then
                newpt = New Point(newpt.X, 0)
            End If
            ToolStrip1.Location = newpt
        End If
    End Sub

    ''' <summary>
    ''' タイマー処理
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Timer1.Stop()

        Try
            ShowNextImage()
        Catch ex As Exception

        End Try
        Timer1.Interval = Interval * 1000
        Timer1.Start()
    End Sub

#Region "ツールバーイベント"
    ''' <summary>
    ''' ツールバー上でのマウス押下。ツールバーの移動（左クリック）と非表示化（右クリック）を行う
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub ToolStrip1_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles ToolStrip1.MouseDown
        If m_bToolSMoveMode Then
            Return
        End If

        If e.Button = Windows.Forms.MouseButtons.Left Then
            m_poiMouse = e.Location
            m_bToolSMoveMode = True
            ToolStrip1.Capture = True
        ElseIf e.Button = Windows.Forms.MouseButtons.Right Then
            ToolStrip1.Visible = False
        End If
    End Sub

    ''' <summary>
    ''' ツールバー上でのマウス移動。ツールバー移動時の処理
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub ToolStrip1_MouseMove(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles ToolStrip1.MouseMove
        If Not e.Button = Windows.Forms.MouseButtons.Left Then
            m_bToolSMoveMode = False
        End If

        If m_bToolSMoveMode Then
            Dim newpt As Point = ToolStrip1.Location + (e.Location - m_poiMouse)

            If newpt.X + ToolStrip1.Width > Me.Width Then
                newpt = New Point(Me.Width - ToolStrip1.Width, newpt.Y)
            End If
            If newpt.Y + ToolStrip1.Height > Me.Height Then
                newpt = New Point(newpt.X, Me.Height - ToolStrip1.Height)
            End If
            If newpt.X < 0 Then
                newpt = New Point(0, newpt.Y)
            End If
            If newpt.Y < 0 Then
                newpt = New Point(newpt.X, 0)
            End If
            ToolStrip1.Location = newpt

            If newpt.X > Me.Width / 2 Then
                ToolStrip1.Anchor = AnchorStyles.Right
            Else
                ToolStrip1.Anchor = AnchorStyles.Left
            End If
            If newpt.Y > Me.Height / 2 Then
                ToolStrip1.Anchor += AnchorStyles.Bottom
            Else
                ToolStrip1.Anchor += AnchorStyles.Top
            End If
        End If
    End Sub

    ''' <summary>
    ''' ツールバー上でのマウス押下解除。ツールバー移動時に移動モードを解除する
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub ToolStrip1_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles ToolStrip1.MouseUp
        If e.Button = Windows.Forms.MouseButtons.Left And m_bToolSMoveMode Then
            m_bToolSMoveMode = False
            ToolStrip1.Capture = False
        End If
    End Sub

    ''' <summary>
    ''' 前の画像ボタン
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub BtnPrev_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnPrev.Click
        ShowPrevImage()
    End Sub

    ''' <summary>
    ''' 次の画像ボタン
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub BtnNext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnNext.Click
        ShowNextImage()
    End Sub

    ''' <summary>
    ''' 再生停止ボタン
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub BtnPause_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnPause.Click
        Play()
    End Sub

    ' ラベル部分で移動を受け付けるようにする
    Private Sub TimerLabel_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles TimerLabel.MouseDown
        ToolStrip1_MouseDown(sender, e)
    End Sub
    Private Sub TimerLabel_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles TimerLabel.MouseUp
        ToolStrip1_MouseUp(sender, e)
    End Sub
    Private Sub TimerLabel_MouseMove(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles TimerLabel.MouseMove
        ToolStrip1_MouseMove(sender, e)
    End Sub

    ''' <summary>
    ''' タイマーの値が変更された
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub ComboTimer_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboTimer.SelectedIndexChanged
        Try
            Dim strTemp As String() = Split(ComboTimer.Text)
            Interval = Convert.ToInt32(strTemp(0))
            If Timer1.Enabled Then
                Timer1.Stop()
                Timer1.Interval = Interval * 1000
                Timer1.Start()
            End If
        Catch ex As Exception

        End Try

        ToolStrip1.Focus()
    End Sub

    ''' <summary>
    ''' 閉じるボタン
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub BtnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnClose.Click
        Me.ParentForm.Close()
    End Sub

    ''' <summary>
    ''' フレーム選択
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub MenuFrame_DropDownItemClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ToolStripItemClickedEventArgs) Handles MenuFrame.DropDownItemClicked
        Dim i As Integer
        Dim tsi As ToolStripMenuItem

        If e.ClickedItem.Text = "なし" Then
            Try
                PictureBox1.Image = Nothing
                My.Settings.FrameName = Nothing

                i = 0
                For Each tsi In MenuFrame.DropDownItems
                    If i = 0 Then
                        tsi.CheckState = CheckState.Checked
                    Else
                        tsi.CheckState = CheckState.Unchecked
                    End If
                    i = i + 1
                Next
            Catch ex As Exception

            End Try
        Else
            Try
                Dim foldername As String
                Dim filename As String
                ' モジュールのフォルダ取得
                Dim modules() As System.Reflection.Module = Assembly.GetExecutingAssembly.GetModules()
                foldername = Path.GetDirectoryName(modules(0).FullyQualifiedName)
                foldername += "\"
                foldername += FRAMEFOLDERNAME
                filename = foldername + "\" + e.ClickedItem.Name
                PictureBox1.Image = Image.FromFile(filename)
                My.Settings.FrameName = e.ClickedItem.Name

                For Each tsi In MenuFrame.DropDownItems
                    If tsi.Name.CompareTo(e.ClickedItem.Name) = 0 Then
                        tsi.CheckState = CheckState.Checked
                    Else
                        tsi.CheckState = CheckState.Unchecked
                    End If
                Next
            Catch ex As Exception

            End Try
        End If
    End Sub
#End Region
#End Region


#Region "ユーザー関数"
    ''' <summary>
    ''' スライドショーの再生を開始する
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub Start()
        If prop_FileList.Count > 0 Then
            Timer1.Interval = 10
            Timer1.Start()
        End If
    End Sub

    ''' <summary>
    ''' 再生停止処理
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub Play()
        If Timer1.Enabled Then
            Timer1.Stop()
            BtnPause.Image = My.Resources.bt_ss_pl
            BtnPause.Text = "Play"
        Else
            Timer1.Start()
            BtnPause.Image = My.Resources.bt_ss_ps
            BtnPause.Text = "Pause"
        End If
    End Sub

    ''' <summary>
    ''' 最大化（元に戻す）処理
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub MaximizeChange()
        If m_bToolSMoveMode Then
            Return
        End If

        If Me.ParentForm.WindowState = FormWindowState.Normal Then
            Me.ParentForm.WindowState = FormWindowState.Maximized
            Me.SizAble = False
            Me.MovAble = False
            Me.Focus()
        ElseIf Me.ParentForm.WindowState = FormWindowState.Maximized Then
            Me.ParentForm.WindowState = FormWindowState.Normal
            Me.SizAble = True
            Me.MovAble = True
        End If
    End Sub

    ''' <summary>
    ''' 次のイメージを表示する
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub ShowNextImage()
        CurItem += 1
        Try
            PictureBox1.BackgroundImage = Image.FromFile(FileList(CurItem))
            PictureBox1.BackgroundImageLayout = ImageLayout.Zoom
        Catch ex As Exception

        End Try
    End Sub

    ''' <summary>
    ''' 前のイメージを表示する
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub ShowPrevImage()
        CurItem -= 1
        Try
            PictureBox1.BackgroundImage = Image.FromFile(FileList(CurItem))
            PictureBox1.BackgroundImageLayout = ImageLayout.Zoom
        Catch ex As Exception

        End Try
    End Sub
#End Region

#Region "プロパティ"
    ''' <summary>
    ''' 再生するファイルのパスのリスト
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    <Category("SlideShow")> _
    <Description("再生するファイルのパスのリスト")> _
    Public Property FileList() As List(Of String)
        Get
            Return prop_FileList
        End Get
        Set(ByVal value As List(Of String))
            prop_FileList = value
            CurItem = -1
        End Set
    End Property

    ''' <summary>
    ''' スライドショーの再生間隔
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    <Category("SlideShow")> _
    <Description("スライドショーの再生間隔")> _
    <DefaultValue(3)> _
    Public Property Interval() As Integer
        Get
            Return prop_Interval
        End Get
        Set(ByVal value As Integer)
            If value < 1 Then
                value = 1
            End If
            If value > MAX_INTERVAL Then
                value = MAX_INTERVAL
            End If
            prop_Interval = value
        End Set
    End Property

    ''' <summary>
    ''' 現在のイメージ番号
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    <Category("SlideShow")> _
    <Description("現在のイメージ番号")> _
    <DefaultValue(0)> _
    Public Property CurItem() As Integer
        Get
            Return prop_CurItem
        End Get
        Set(ByVal value As Integer)
            prop_CurItem = value

            If FileList IsNot Nothing Then
                If prop_CurItem > FileList.Count - 1 Then
                    prop_CurItem = 0
                End If
                If prop_CurItem < 0 Then
                    prop_CurItem = FileList.Count - 1
                End If
            End If
        End Set
    End Property
#End Region
End Class
